#Community Accounting

For an architectural description see: http://matslats.net/mutual-credit-architecture-4

For a full description of the module, visit the
[project page](https://www.drupal.org/project/mutual_credit).

Submit bug reports and feature suggestions, or track changes in the
[issue queue](https://www.drupal.org/project/issues/mutual_credit).

**WARNING!**

The intention behind this module is to foster a culture of experimentation, not 
to impose ideological constraints about how   a money system should work. 
Consequently it can be used as straight mutual credit, as the name implies, or 
for fiat or asset currencies in which units are 'issued' into circulation from 
an account allocated for that purpose. Nonetheless, fools rush in where angels 
fear to tread! Many lessons have already been learned about currency design and 
the process of encouraging communities to adopt them. A badly managed accounting 
system can cause people to lose out and create bad feeling and resistance to 
future innovation, especially because few people understand how money actually 
works.


## Requirements (required)

This module requires the following modules:

- [Bad judgement](https://www.drupal.org/project/bad_judgement)


## Installation

**ENABLE MODULES**

Enable Community Accounting API, Forms designer and optionally others from the 
Community Accounting Section. You may also want Field UI to add fields to 
transactions or wallets.
  
Two wallets are created by default so the transaction forms will work 
immediately; both belong to user 1; The first is named after user 1, the second 
is called 'Spare'

Visit `admin/accounting/misc` and specify the maximum number of wallets users 
can hold (except user 1). Choose which view to show as a transactions tab on the
wallet page.

Visit `admin/accounting/transaction/workflows` and design the workflows. Note than workflows 
inherited from a credit commons node can only be translated, not edited. Each 
workflow generates a default transaction form, visible at transact/


Visit `admin/accounting/transactions` to add and manage fields. Notice that you 
cant do much with transaction form Displays.


Add fields to wallets at admin/accounting/wallets

**Limits**

- Most projects require that accounts have 'overdraft' limits and, in mutual credit, positive balance limits.
  The limits module provides a new section on the currency settings page
  Also if personal overrides are enabled, those are configured on the user profile.

**Credit Commons**

[Credit Commons](http://creditcommons.net) is a protocol for reading and writing mutual credit over a rest 
API, but more relevantly here, it also helps groups to trade with each other. 

- External intertrading happens between web servers via a 3rd party web service.
  Currently the only such service available is Clearing Central, provided by CES.
  We are working on another service provisionally called the Credit Commons.

## Configuration
Configure how the unit of account is formatted by specifying the prefix, 
separator, divisor, and fractions and suffix in a single string. For example to 
show hours and quarters of an hour put

H0:59/4m

## Advanced Tips

@todo rewrite all this

- Intended for Drupal developers

    1. Transaction processing hooks
    2. Transaction Worflow
    3. Forms designer
    4. Limits system
    5. Views integration
    
    1. Transaction processing hooks
    
    2. Transaction workflow.

- Workflow is built up using mc_workflow and mc_state entities, with a special type of action being used as the workflow    transition
  By default, transactions are created in FINISHED state, and the 'undo' transition is visible only to permitted users.
  The signatures module shows how transaction workflow can be augmented with a new type, a new state, and two actions
  These actions are also used for entity operations

3. Forms designer

- Of course you can build your own forms using modules for creating transactions, but this powerful form builder is        provided. Each form has its own address in the menu system, access control, and can be available as a block also.
 The administrator can design forms in HTML for different purposes and different places in the site.
  The HTML template contains tokens for each transaction property / field, elements not referenced by tokens are hidden and must have preset values. Properties and fields can be preset or otherwise configured also Note that most fields can also be 'stripped' which removes the outer box, making them easier to theme.
  The date field is available (as a token only) to allow transactions to be backdated.
  The form has an optional confirmation page, the format of which can also be determined.

4. Limits system

- During the accounting_validate phase the limits module checks whether the transaction cluster would put any users over      their limits.
- Limits are determined by callbacks, per currency, and are not saved in the database.
  Limts can optionally be overridden by user profile settings and custom modules can add more callbacks
  Under some circumstances limits could be exceeded, such as with automated transactions, or user 1 initiated transactions.
  In that case only transactions will be permitted which bring users towards zero.
- The limits module provides blocks to show
- the balance and the min/max limits
- the amount which can be earned or spent before limits are hit.

5. Views integration

- Depending on what you want to view, you might build the view not with the transaction entity, but on either of the two      transaction index tables which exist for that purpose.

## Maintainers

- Matthew Slater (matslats) - https://www.drupal.org/u/matslats
