<?php

namespace Drupal\mcapi_cc;

use Drupal\Core\Entity\EntityInterface;

/**
 * Defines a class to build a listing of Workflow config entities.
 *
 */
class WorkflowListBuilder extends \Drupal\mcapi\Entity\ListBuilder\WorkflowListBuilder {

  /**
   * {@inheritDoc}
   */
  public function buildHeader() {
    return parent::buildHeader() + ['scope' => $this->t('Scope')];
  }

  /**
   * {@inheritDoc}
   */
  public function buildRow(EntityInterface $entity) {
    $output = $entity->home;
    if ($entity->disabled) {
      $output .= ' ('. t('Disabled') .')';
    }
    return parent::buildRow($entity) + [
      'scope' => [
        'data' => [
          '#markup' => $output
        ]
      ]
    ];
  }

}
