<?php

namespace Drupal\mcapi\Entity\Access;

use Drupal\Core\Routing\Access\AccessInterface;
use Drupal\Core\Session\AccountInterface;
use Drupal\Core\Access\AccessResult;

/**
 * Determines access to create transaction routes according to the permission for each workflow
 */
class CreateTransaction implements AccessInterface  {

  /**
   * @param string $mc_workflow
   * @param AccountInterface $account
   * @return AccessResult
   */
   public function access(string $mc_workflow, AccountInterface $account) : AccessResult {
    return AccessResult::allowedIfHasPermission($account, "create $mc_workflow transaction");
  }
}
