<?php

namespace Drupal\mcapi\Entity;

use Drupal\Core\Entity\ContentEntityInterface;
use Drupal\Core\Entity\RevisionableInterface;
use Drupal\mcapi\Plugin\Field\FieldType\EntryItem;
use CreditCommons\TransactionInterface as CCTransactionInterface;

/**
 * Interface for Transaction entity.
 */
interface TransactionInterface extends ContentEntityInterface, RevisionableInterface {

  const COUNTED_STATES = [CCTransactionInterface::STATE_COMPLETED, CCTransactionInterface::STATE_PENDING];

  function addEntry(array $params) : EntryItem|NULL;

  /**
   * Get all the IDs of all wallets involved in all the transaction entries.
   * @return int[]
   */
  function allWalletIds() : array;

}
